/***************************************************************************
                          net.h  -  description
                             -------------------
    begin                : t z 18 2003
    copyright            : (C) 2003 by Petr Cermak
    email                : cermak01@seznam.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _NET_H_
#define _NET_H_
 
#include <sys/types.h>
#include "game.h"

typedef int NetMsgType;
#define NM_PLAYAT 0
#define NM_MSG 1
#define NM_STOP 2
#define NM_GAME 3
#define NM_PASS 4

typedef struct {
	NetMsgType type;
	int x;
	int y;
	char str[256];
} NetMessage;

int serverAccept(int port);
int clientConnect(char* host, int port);

int storeGame(int fd, Game* g);
Game* readGame(int fd, Boolean useRecv);
Boolean saveGameToFile(char* fileName, Game* g);
Game* loadGameFromFile(char* fileName);

Boolean recvNetMessage(int fd, NetMessage* msg);
Boolean sendNetMessage(int fd, NetMessage* msg);

Boolean sendCommand(int fd, NetMsgType type);
Boolean sendCommandMsg(int fd, char* msg);
Boolean sendCommandPlay(int fd, int x, int y);

#endif
